Attribute VB_Name = "modUtilita"
'================================================================
' Descrizione.....: Collezione di routines e costanti di utilita'
'                   per il "Delaunay"; non tutte le routines di
'                   questo modulo sono presentemente usate.
' Nome dei Files..: modUtilita.bas
' Data............: 4/10/2002
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows NT (SP6).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'                   http://members.xoom.virgilio.it/flanguasco/
'================================================================
'
Option Explicit
'
Public Const PI# = 3.14159265358979    ' 4# * Atn(1#)
Public Const PI2# = 2# * PI
Public Const PI_2# = PI / 2#           ' 90 in [rad].
Public Const Log10# = 2.30258509299405
'
Public Type P_Type
    X As Double         ' Coordinate x dei punti.
    Y As Double         ' Coordinate y dei punti.
    Z As Double         ' Coordinate z dei punti.
End Type
'
'--- GetLocale: ----------------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
    (ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String, _
    ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_SDECIMAL& = &HE
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDATE& = &H1D
Private Const LOCALE_STIME& = &H1E
Public Function SIGN(ByVal dV#, ByVal dS#) As Double
'
'   Ritorna il valore assoluto di dV con il segno di dS.
'   Implementa la funzione SIGN del FORTRAN:
'
    If dS < 0 Then
        SIGN = -Abs(dV)
    Else
        SIGN = Abs(dV)
    End If
'
'
'
End Function
Public Function NextPrime(ByVal K&) As Long
'
'   Ritorna un numero primo maggiore o uguale a K.
'
    Dim K1&
'
    K1 = K
    If K1 Mod 2 = 0 Then K1 = K1 + 1
'
    Do While (Not Primo(K1))
        K1 = K1 + 2
    Loop

    NextPrime = K1
'
'
'
End Function
Private Function Primo(ByVal NP&) As Boolean
'
'
'   Ritorna True se NP e' un numero primo.
'
    Dim ISqrNP&, I&
'
    If ((NP Mod 2) = 0) Then
        Primo = False
        Exit Function
    End If
'
    ISqrNP = Ceil(Sqr(CDbl(NP)))
'
    For I = 3 To ISqrNP Step 2
        If ((NP Mod I) = 0) Then
            Primo = False
            Exit Function
        End If
    Next I
'
    Primo = True
'
'
'
End Function
Public Function Segmento_3D(ByVal X1#, ByVal Y1#, ByVal Z1#, _
    ByVal X2#, ByVal Y2#, ByVal Z2#, _
    Pc() As P_Type) As Boolean
'
'   Ritorna, nel vettore Pc(), i valori del segmento congiungente
'   i punti P1(X1, Y1, Z1) --> P2(X2, Y2, Z2).
'
   Dim I&, NPC&
   Dim Dx#, Dy#, Dz#
'
    On Error GoTo Segmento_3D_ERR
'
    NPC = UBound(Pc) ' N. di punti sul segmento.
'
    Dx = (X2 - X1) / CDbl(NPC - 1)
    Dy = (Y2 - Y1) / CDbl(NPC - 1)
    Dz = (Z2 - Z1) / CDbl(NPC - 1)
'
    For I = 1 To NPC
        Pc(I).X = X1 + Dx * CDbl(I - 1)
        Pc(I).Y = Y1 + Dy * CDbl(I - 1)
        Pc(I).Z = Z1 + Dz * CDbl(I - 1)
    Next I
'
'
Segmento_3D_ERR:
    Segmento_3D = (Err = 0)
    If (Err <> 0) Then
        Dim M$
        M$ = "I parametri del segmento" & vbNewLine _
           & "non sono validi."
        MsgBox M$, vbCritical, " Errore in Segmento_3D"
    End If
'
'
'
End Function
Public Function Arco_3D(ByVal X1#, ByVal Y1#, ByVal Z1#, _
    ByVal X2#, ByVal Y2#, ByVal Z2#, _
    ByVal X3#, ByVal Y3#, ByVal Z3#, _
    Pc() As P_Type) As Boolean
'
'   Ritorna, nel vettore Pc(), i valori dell' arco passante
'   per i tre punti P1(X1, Y1, Z1), P2(X2, Y2, Z2) e P3(X3, Y3, Z3).
'   La curva e' calcolata in modo parametrico (0 <= u <= 1)
'   con il valore 0 di u corrispondente a Pc(1) (punto P1(X1, Y1, Z1)) e
'   con il valore 1 di u corrispondente a Pc(NPC) (punto P3(X3, Y3, Z3)).
'
'   Le formule usate in questa routine mi sono state
'   gentilmente fornite da:
'    El Filibustero <spalland@comune.re.it>
'   Egli fa' comunque notare che potrebbero esserci
'   routines migliori.
'
   Dim I&, NPC_1&
   Dim Xp#, d13#, xq#, yq#, a#, d#, g#, b#, e#, h#, Den#, xx#, yy#, u#
   Dim Xc#, Yc#, R#, Alpha#, t0#, T1#
'
    On Error GoTo Arco_3D_ERR
'
    NPC_1 = UBound(Pc) - 1 ' N. di punti sull' arco - 1.
'
    ' L' arco inizia da X1, Y1, Z1:
    Pc(1).X = X1
    Pc(1).Y = Y1
    Pc(1).Z = Z1
'
    ' Variabili ausiliarie:
    Xp = Sqr((X2 - X1) * (X2 - X1) + (Y2 - Y1) * (Y2 - Y1) + (Z2 - Z1) * (Z2 - Z1))
    d13 = (X3 - X1) * (X3 - X1) + (Y3 - Y1) * (Y3 - Y1) + (Z3 - Z1) * (Z3 - Z1)
    xq = ((X3 - X1) * (X2 - X1) + (Y3 - Y1) * (Y2 - Y1) + (Z3 - Z1) * (Z2 - Z1)) / Xp
    yq = Sqr(d13 - xq * xq)
    Xc = Xp / 2#
    Yc = (xq * xq + yq * yq - Xp * xq) / (2# * yq)
    R = Sqr(Xc * Xc + Yc * Yc)
    t0 = Atn(Yc / Xc) - PI
    If Xc = xq Then
        T1 = PI / 2#
    ElseIf xq > Xc Then
        T1 = Atn((yq - Yc) / (xq - Xc))
    Else
        T1 = Atn((yq - Yc) / (xq - Xc)) + PI
    End If
'
    a = (X2 - X1) / Xp
    d = (Y2 - Y1) / Xp
    g = (Z2 - Z1) / Xp
    b = (X3 - a * xq - X1) / yq
    e = (Y3 - d * xq - Y1) / yq
    h = (Z3 - g * xq - Z1) / yq
'
    For I = 2 To NPC_1
        u = CDbl(I - 1) / CDbl(NPC_1)
'
        ' Variabili dipendenti dal parametro u:
        Alpha = (T1 - t0) * u + t0
        xx = Xc + R * Cos(Alpha)
        yy = Yc + R * Sin(Alpha)
'
        ' e finalmente ....
        Pc(I).X = a * xx + b * yy + X1
        Pc(I).Y = d * xx + e * yy + Y1
        Pc(I).Z = g * xx + h * yy + Z1
    Next I
'
    ' L' arco finisce su X3, Y3, Z3:
    Pc(NPC_1 + 1).X = X3
    Pc(NPC_1 + 1).Y = Y3
    Pc(NPC_1 + 1).Z = Z3
'
'
Arco_3D_ERR:
    Arco_3D = (Err = 0)
    If (Err <> 0) Then
        Dim M$
        M$ = "Le coordinate dei punti dell' arco" & vbNewLine _
           & "non sono valide."
        MsgBox M$, vbCritical, " Errore in Arco_3D"
    End If
'
'
'
End Function
Public Function Cerchio3P_3D(ByVal X1#, ByVal Y1#, ByVal Z1#, _
    ByVal X2#, ByVal Y2#, ByVal Z2#, _
    ByVal X3#, ByVal Y3#, ByVal Z3#, _
    Pc() As P_Type) As Boolean
'
'   Ritorna, nel vettore Pc(), i valori del cerchio passante
'   per i tre punti P1(X1, Y1, Z1), P2(X2, Y2, Z2) e P3(X3, Y3, Z3).
'   La curva e' calcolata in modo parametrico (0 <= u <= 1)
'   con il valore 0 di u corrispondente a Pc(1) (punto P1(X1, Y1, Z1)) e
'   con il valore 1 di u corrispondente a Pc(NPC) (punto P1(X1, Y1, Z1)).
'
'   Le formule usate in questa routine mi sono state
'   gentilmente fornite da:
'    El Filibustero <spalland@comune.re.it>
'   Egli fa' comunque notare che potrebbero esserci
'   routines migliori.
'
   Dim I&, NPC_1&
   Dim Xp#, d13#, xq#, yq#, a#, d#, g#, b#, e#, h#, Den#, xx#, yy#, u#
   Dim Xc#, Yc#, R#, Alpha#, t0#, T1#
'
    On Error GoTo Cerchio3P_3D_ERR
'
    NPC_1 = UBound(Pc) - 1 ' N. di punti sull' arco - 1.
'
    ' Il cerchio inizia da X1, Y1, Z1:
    Pc(1).X = X1
    Pc(1).Y = Y1
    Pc(1).Z = Z1
'
    ' Variabili ausiliarie:
    Xp = Sqr((X2 - X1) * (X2 - X1) + (Y2 - Y1) * (Y2 - Y1) + (Z2 - Z1) * (Z2 - Z1))
    d13 = (X3 - X1) * (X3 - X1) + (Y3 - Y1) * (Y3 - Y1) + (Z3 - Z1) * (Z3 - Z1)
    xq = ((X3 - X1) * (X2 - X1) + (Y3 - Y1) * (Y2 - Y1) + (Z3 - Z1) * (Z2 - Z1)) / Xp
    yq = Sqr(d13 - xq * xq)
    Xc = Xp / 2#
    Yc = (xq * xq + yq * yq - Xp * xq) / (2# * yq)
    R = Sqr(Xc * Xc + Yc * Yc)
    t0 = Atn(Yc / Xc) - PI
'
    a = (X2 - X1) / Xp
    d = (Y2 - Y1) / Xp
    g = (Z2 - Z1) / Xp
    b = (X3 - a * xq - X1) / yq
    e = (Y3 - d * xq - Y1) / yq
    h = (Z3 - g * xq - Z1) / yq
'
    For I = 2 To NPC_1
        u = CDbl(I - 1) / CDbl(NPC_1)
'
        ' Variabili dipendenti dal parametro u:
        Alpha = PI2 * u + t0
        xx = Xc + R * Cos(Alpha)
        yy = Yc + R * Sin(Alpha)
'
        ' e finalmente ....
        Pc(I).X = a * xx + b * yy + X1
        Pc(I).Y = d * xx + e * yy + Y1
        Pc(I).Z = g * xx + h * yy + Z1
    Next I
'
    ' Il cerchio finisce su X1, Y1, Z1:
    Pc(NPC_1 + 1).X = X1
    Pc(NPC_1 + 1).Y = Y1
    Pc(NPC_1 + 1).Z = Z1
'
'
Cerchio3P_3D_ERR:
    Cerchio3P_3D = (Err = 0)
    If (Err <> 0) Then
        Dim M$
        M$ = "Le coordinate dei punti del cerchio" & vbNewLine _
           & "non sono valide."
        MsgBox M$, vbCritical, " Errore in Cerchio3P_3D"
    End If
'
'
'
End Function
Public Function Cerchio_3D(ByVal Xc#, ByVal Yc#, ByVal Zc#, _
    ByVal Xd#, ByVal Yd#, ByVal Zd#, ByVal R#, _
    Pc() As P_Type) As Boolean
'
'   Ritorna, nel vettore Pc(), i valori del cerchio con centro in Pc(Xc, Yc, Zc),
'   di raggio R e con vettore normale Pc(Xc, Yc, Zc) --> Pd(Xd, Yd, Zd).
'   La curva e' calcolata in modo parametrico (0 <= u <= 1).
'
   Dim I&, NPC&
   Dim Vd#, Alpha#, AlphaZX#, AlphaZY#, u#
'
    On Error GoTo Cerchio_3D_ERR
'
    NPC = UBound(Pc) ' N. di punti sul cerchio.
'
    Vd = SIGN(Sqr((Xd - Xc) ^ 2 + (Yd - Yc) ^ 2 + (Zd - Zc) ^ 2), Zd - Zc)
    AlphaZX = -Asin((Xd - Xc) / Vd)
    AlphaZY = -Asin((Yd - Yc) / (Vd * Cos(AlphaZX)))
'
    For I = 1 To NPC
        u = CDbl(I - 1) / CDbl(NPC - 1)
'
        ' Calcolo in Pc() i punti di un cerchio con
        ' centro (0, 0, 0), di raggio R e giacente sul piano X-Y:
        Alpha = PI2 * u
        Pc(I).X = R * Cos(Alpha)
        Pc(I).Y = R * Sin(Alpha)
        Pc(I).Z = 0#
'
        ' ruoto i punti calcolati precedentemente nella
        ' direzione del vettore Pc(Xc, Yc, Zc) --> Pd(Xd, Yd, Zd):
        Ruota Pc(I).X, Pc(I).Z, AlphaZX, 0#, 0#, Pc(I).X, Pc(I).Z
        Ruota Pc(I).Y, Pc(I).Z, AlphaZY, 0#, 0#, Pc(I).Y, Pc(I).Z
'
        ' ed infine li sposto con
        ' centro su Pc(Xc, Yc, Zc):
        Pc(I).X = Xc + Pc(I).X
        Pc(I).Y = Yc + Pc(I).Y
        Pc(I).Z = Zc + Pc(I).Z
    Next I
'---------------------------------------------------------------------------------------
    ' Debug:
    Dim Dist#, DistMin#, DistMax#
    DistMin = 1E+38
    DistMax = -1E+38
    For I = 1 To NPC
        Dist = Sqr((Xd - Pc(I).X) ^ 2 + (Yd - Pc(I).Y) ^ 2 + (Zd - Pc(I).Z) ^ 2)
        DistMin = DMIN1(DistMin, Dist)
        DistMax = DMAX1(DistMax, Dist)
    Next I
    If (DistMax - DistMin) > 0.01 Then Stop
    
'    Debug.Print Vd
'    For I = 1 To NPC
'        Debug.Print Sqr((Xc - Pc(I).X) ^ 2 + (Yc - Pc(I).Y) ^ 2 + (Zc - Pc(I).Z) ^ 2); _
'                    Sqr((Xd - Pc(I).X) ^ 2 + (Yd - Pc(I).Y) ^ 2 + (Zd - Pc(I).Z) ^ 2)
'    Next I
'    Debug.Print
'---------------------------------------------------------------------------------------
'
'
Cerchio_3D_ERR:
    Cerchio_3D = (Err = 0)
    If (Err <> 0) Then
        Dim M$
        M$ = "I parametri del cerchio" & vbNewLine _
           & "non sono validi."
        MsgBox M$, vbCritical, " Errore in Cerchio_3D"
    End If
'
'
'
End Function
Private Sub Ruota(ByVal X0#, ByVal Y0#, ByVal Rot#, ByVal CRx#, ByVal CRy#, Xr#, Yr#)
'
'   Routine per la rotazione di un punto:
'
'   X0, Y0:     coordinate del punto da ruotare.
'   Rot:        rotazione del punto in [rad].
'   CRx, CRy:   coordinate del centro di rotazione.
'   Xr, Yr:     coordinate finali del punto ruotato.
'
    ' Rotazione:
    Xr = (X0 - CRx) * Cos(Rot) - (Y0 - CRy) * Sin(Rot) + CRx
    Yr = (X0 - CRx) * Sin(Rot) + (Y0 - CRy) * Cos(Rot) + CRy
'
'
'
End Sub
Private Function Asin(ByVal X As Double) As Double
'
'   Calcola l' ArcoSeno di x con -1 <= x <= 1.
'   Asin e' in radianti.
'   E':    -PI/2 <= Asin <= PI/2.
'
    If Abs(X) < 1# Then
        Asin = Atn(X / Sqr(1# - X * X))
    ElseIf X = 1# Then
        Asin = PI / 2#
    ElseIf X = -1# Then
        Asin = -PI / 2#
    Else
        Err.Raise 5, "Asin Function", "Argomento illegale per Asin"
    End If
'
'
'
End Function
Public Sub Cartesiane_Sferiche(ByVal X#, ByVal Y#, ByVal Z#, _
    ByRef Rho#, ByRef THETA#, ByRef Phi#)
'
'   Converte le coordinate da cartesiane a sferiche.
'    Rho = raggio vettore.
'    Theta = colatitudine (0 < Theta < PI).
'    Phi = longitudine (0 <= Phi < 2*PI).
'
    Rho = Sqr(X * X + Y * Y + Z * Z)
    If Rho > 0 Then
        THETA = Acos(Z / Rho)
        Phi = Atan2(Y, X)
    Else
        THETA = PI_2
        Phi = 0#
    End If
'
'
'
End Sub
Private Function Acos(ByVal X As Double) As Double
'
'   Calcola l' ArcoCoseno di x con -1 <= x <= 1.
'   Acos e' in radianti.
'
    If 0# < X And X <= 1# Then
        Acos = Atn(Sqr(1# - X * X) / X)
    ElseIf -1# <= X And X < 0# Then
        Acos = PI + Atn(Sqr(1# - X * X) / X)
    ElseIf X = 0# Then
        Acos = PI / 2#
    Else
        Err.Raise 5, "Acos Function", "Argomento illegale per Acos"
    End If
'
'
'
End Function
Public Sub Sferiche_Cartesiane(ByVal Rho#, ByVal THETA#, ByVal Phi#, _
    ByRef X#, ByRef Y#, ByRef Z#)
'
'   Converte le coordinate da sferiche a cartesiane.
'    Rho = raggio vettore.
'    Theta = colatitudine (0 < Theta < PI).
'    Phi = longitudine (0 <= Phi < 2*PI).
'
    X = Rho * Sin(THETA) * Cos(Phi)
    Y = Rho * Sin(THETA) * Sin(Phi)
    Z = Rho * Cos(THETA)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$ _
    , Optional ByVal MAXFIL& = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim a$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        a$ = mnuRecenti(F).Caption
        If UCase$(Right$(a$, Len(a$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        a$ = mnuRecenti(I - 1).Caption
        a$ = "&" & Trim$(Str$(I)) & " " & Right$(a$, Len(a$) - 3)
        mnuRecenti(I).Caption = a$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$ _
    , Optional ByVal MAXFIL& = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge dal Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti e li aggiunge al menu mnuRecenti().
'   Se VerificaFE = True verifica anche l' esistenza dei files da
'   aggiungere:
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If FileRec$ <> "" Then
            If VerificaFE Then
                If FileExists(FileRec$) Then _
                    AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$, MAXFIL
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva nel Registry di Windows e se e' definito il "Product Name"
'   del progetto, i files recenti contenuti nel menu mnuRecenti():
'
    Dim I&, FileRec$
'
    If App.ProductName = "" Then Exit Sub
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Sub SalvaPosizioneForm(ByVal frmF As Form _
    , Optional ByVal Dimensioni As Boolean = False)
'
'   Salva, sul Registry di Window e se e' definito il
'   "Product Name" del progetto, la posizione finale
'   del Form frmF.  Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    If (frmF.WindowState <> vbMinimized) And (App.ProductName <> "") Then
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Left", frmF.Left
        SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Top", frmF.Top
'
        If Dimensioni Then
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Width", frmF.Width
            SaveSetting App.ProductName, "PosizioniForms", frmF.Name & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Sub LeggiPosizioneForm(ByVal frmF As Form, ByRef frmF_Left&, ByRef frmF_Top& _
    , Optional ByRef frmF_Width&, Optional ByRef frmF_Height&)
'
'   Legge, se e' definito il "Product Name" del progetto, la posizione
'   iniziale e le dimensioni  del Form frmF memorizzate sul Registry di Window.
'   Da usare nell' evento frmF_Load e con frmF.StartUpPosition = vbStartUpManual:
'
    If App.ProductName <> "" Then
        frmF_Left = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Left", 0))
        frmF_Top = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Top", 0))
'
        frmF_Width = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Width", Screen.Width))
        frmF_Height = Val(GetSetting(App.ProductName, "PosizioniForms", frmF.Name & "_Height", Screen.Height))
    Else
        frmF_Left = 0
        frmF_Top = 0
'
        frmF_Width = frmF.Width
        frmF_Height = frmF.Height
    End If
'
'
'
End Sub
Public Function DATAN2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x
'   come implementata dal FORTRAN.
'   E':    -PI < DATAN2 <= PI.
'
    Select Case X
    Case Is > 0#
        DATAN2 = Atn(Y / X)
'
    Case Is < 0#
        If Y >= 0# Then
            DATAN2 = Atn(Y / X) + PI
        ElseIf Y < 0# Then
            DATAN2 = Atn(Y / X) - PI
        End If
'
    Case Is = 0#
        DATAN2 = Sgn(Y) * PI / 2#
    End Select
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA%, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
    Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer _
    , Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
    Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
    Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(Optional ByRef dS$, Optional ByRef MS$, _
    Optional ByRef GS$, Optional ByRef TS$)
'
'   Trova i separatori del sistema:
'    DS$:   separatore decimale.
'    MS$:   separatore delle migliaia.
'    GS$:   separatore dei giorni.
'    TS$:   separatore delle ore.
'
    dS$ = "  "
    MS$ = "  "
    GS$ = "  "
    TS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, dS$, Len(dS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_SDATE, GS$, Len(GS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STIME, TS$, Len(TS$)
'
    dS$ = Left$(dS$, 1)
    MS$ = Left$(MS$, 1)
    GS$ = Left$(GS$, 1)
    TS$ = Left$(TS$, 1)
'
'
'
End Sub

Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I&
'
    For I = 0 To Forms.Count - 1
        If Forms(I) Is frmF Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function TabellaColori(ByVal NCol&) As Long()
'
'   Ritorna un vettore contenente NCol (2, 16, 256, 1280 o 1792) colori
'   in formato RGB.  La scala di colore, per NCOL = 1280, va' dal Viola
'   al Rosso; per NCOL = 1792, va' dal Bianco al Nero:
'
    Dim c&, C1&, C2&
    Dim R&, g&, b&
    ReDim TCol(0 To NCol - 1) As Long ' Tabella dei colori.
'
    Select Case NCol
    Case 2
        ' Prepara la tabella a 2 colori:
        TCol(0) = vbWhite
        TCol(1) = &H808080 ' Grigio.
'
    Case 16
        ' Prepara la tabella a 16 colori:
        For c = 0 To 15
            R = 255 * (Sqr(c) / Sqr(15))
            If c < 8 Then
                g = CLng(255 * (Sqr(c) / Sqr(7)))
            Else
                g = CLng(255 * (Sqr(15 - c) / Sqr(7)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(15))
'
            TCol(c) = RGB(R, g, b)
        Next c
'
    Case 256
        ' Prepara la tabella a 256 colori:
        For c = 0 To 255
            R = 255 * (Sqr(c) / Sqr(255))
            If c < 128 Then
                g = CLng(255 * (Sqr(c) / Sqr(127)))
            Else
                g = CLng(255 * (Sqr(255 - c) / Sqr(127)))
            End If
            b = 255 * (1! - Sqr(c) / Sqr(255))
'
            TCol(c) = RGB(R, g, b)
        Next c
'
    Case 1280
        ' Prepara la tabella a 1280 colori:
        c = 0
        For C1 = 0 To 4
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, 0 _
                         , C1 = 3, C2 _
                         , C1 = 4, 255)
                g = Switch(C1 = 0, 0 _
                         , C1 = 1, C2 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 - C2)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 - C2 _
                         , C1 = 3, 0 _
                         , C1 = 4, 0)
'
                TCol(c) = RGB(R, g, b)
                c = c + 1
            Next C2
        Next C1
'
    Case 1792
        ' Prepara la tabella a 1792 colori:
        For C1 = 0 To 6
            For C2 = 0 To 255
                R = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 - C2 _
                         , C1 = 2, 0 _
                         , C1 = 3, 0 _
                         , C1 = 4, C2 _
                         , C1 = 5, 255 _
                         , C1 = 6, 255 - C2)
                g = Switch(C1 = 0, 255 - C2 _
                         , C1 = 1, 0 _
                         , C1 = 2, C2 _
                         , C1 = 3, 255 _
                         , C1 = 4, 255 _
                         , C1 = 5, 255 - C2 _
                         , C1 = 6, 0)
                b = Switch(C1 = 0, 255 _
                         , C1 = 1, 255 _
                         , C1 = 2, 255 _
                         , C1 = 3, 255 - C2 _
                         , C1 = 4, 0 _
                         , C1 = 5, 0 _
                         , C1 = 6, 0)
'
                TCol(c) = RGB(R, g, b)
                c = c + 1
            Next C2
        Next C1
    End Select
'
    TabellaColori = TCol()
'
'
'
End Function
Public Function RandU(ByVal V_Min!, ByVal V_Max!) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function
Public Sub Decima3D(ByRef dV1#(), ByRef dV2#(), ByRef dV3#(), Optional ByRef lNV&)
'
'   Elimina dai vettori dV1(), dV2() e dV3() gli
'   elementi a tre a tre uguali.
'   I tre vettori devono avere le stesse dimensioni.
'   lNV e' il numero degli elementi rimasti:
'
    Dim I&, J&, Il&, Iu&, K&
'
    Il = LBound(dV1)
    Iu = UBound(dV1)
    I = Il - 1
'
    Do
        I = I + 1
        J = I + 1
        Do While J <= Iu
            If (dV1(I) = dV1(J)) And (dV2(I) = dV2(J)) And (dV3(I) = dV3(J)) Then
                For K = J To Iu - 1
                    dV1(K) = dV1(K + 1)
                    dV2(K) = dV2(K + 1)
                    dV3(K) = dV3(K + 1)
                Next K
                Iu = Iu - 1
            Else
                J = J + 1
            End If
        Loop
    Loop While I < Iu
'
    lNV = Iu - Il + 1
    ReDim Preserve dV1(Il To Iu), dV2(Il To Iu), dV3(Il To Iu)
'
'
'
End Sub
Public Function Decima(dV#(), Optional ByRef lNV&) As Double()
'
'   Ritorna un vettore con gli elementi di dV()
'   ma senza i doppioni.
'   lNV e' il numero degli elementi rimasti:
'
    Dim I&, J&, Il&, Iu&, K&, dVT#()
'
    Il = LBound(dV)
    Iu = UBound(dV)
    I = Il - 1
    dVT() = dV()
'
    Do
        I = I + 1
        J = I + 1
        Do While J <= Iu
            If dVT(I) = dVT(J) Then
                For K = J To Iu - 1
                    dVT(K) = dVT(K + 1)
                Next K
                Iu = Iu - 1
            Else
                J = J + 1
            End If
        Loop
    Loop While I < Iu
'
    lNV = Iu - Il + 1
    ReDim Preserve dVT(Il To Iu)
'
    Decima = dVT()
'
'
'
End Function
Public Sub QuickSort(ByRef ValTab() As Double, ByVal Low&, ByVal High&, _
    Optional ByVal Verso& = -1)
'
'   Routine QuickSort:
'    ValTab():  Vettore che si vuole ordinare.
'    Low:       Posizione iniziale della zona da ordinare.
'    High:      Posizione finale della zona da ordinare.
'    Verso:     Direzione dell' ordinamento:
'                > 0 -> dal minore al maggiore.
'                = 0 -> nessun ordinamento.
'                < 0 -> dal maggiore al minore.
'
    Dim RandIndex&, I&, J&, M$
    Dim ValTemp As Double   ' Tipo del vettore che si vuole ordinare.
    Dim Part As Double      ' Tipo della chiave di ordinamento.
'
    On Error GoTo QuickSort_ERR
    If Verso = 0 Then Exit Sub
'
    If Low < High Then
'
        If High - Low = 1 Then
            ' Only two elements in this subdivision; swap them
            ' if they are out of order, then end recursive calls:
            If ((Verso > 0) And (ValTab(Low) > ValTab(High))) _
            Or ((Verso < 0) And (ValTab(Low) < ValTab(High))) Then
                'SWAP ValTab(Low), ValTab(High)
                ValTemp = ValTab(Low)
                ValTab(Low) = ValTab(High)
                ValTab(High) = ValTemp
            End If
'
        Else
            ' Pick a pivot element, then move it to the end:
            RandIndex = (High + Low) / 2
            'SWAP ValTab(High), ValTab(RandIndex)
            ValTemp = ValTab(High)
            ValTab(High) = ValTab(RandIndex)
            ValTab(RandIndex) = ValTemp
            Part = ValTab(High)
'
            ' Move in from both sides towards the pivot element:
            Do
                I = Low: J = High
                Do While ((Verso > 0) And (I < J) And (ValTab(I) <= Part)) _
                Or ((Verso < 0) And (I < J) And (ValTab(I) >= Part))
                    I = I + 1
                Loop
                Do While ((Verso > 0) And (J > I) And (ValTab(J) >= Part)) _
                Or ((Verso < 0) And (J > I) And (ValTab(J) <= Part))
                    J = J - 1
                Loop
'
                If I < J Then
                    ' We haven't reached the pivot element; it means that two
                    ' elements on either side are out of order, so swap them:
                    'SWAP ValTab(I), ValTab(J)
                    ValTemp = ValTab(I)
                    ValTab(I) = ValTab(J)
                    ValTab(J) = ValTemp
                End If
'
            Loop While I < J
            ' Move the pivot element back to its proper place in the array:
            'SWAP ValTab(I), ValTab(High)
            ValTemp = ValTab(I)
            ValTab(I) = ValTab(High)
            ValTab(High) = ValTemp
'
            ' Recursively call the QuickSort procedure (pass the smaller
            ' subdivision first to use less stack space):
            If (I - Low) < (High - I) Then
                QuickSort ValTab(), Low, I - 1, Verso
                QuickSort ValTab(), I + 1, High, Verso
            Else
                QuickSort ValTab(), I + 1, High, Verso
                QuickSort ValTab(), Low, I - 1, Verso
            End If
        End If
    End If
'
'
QuickSort_ERR:
    If (Err <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " QuickSort"
    End If
'
'
'
End Sub
Public Function CMDialog_Files(ByVal CMDialog As CommonDialog, ByVal Oper$, _
    ByVal Tipo$, ByVal Ext$, Optional ByVal DirNome$ = "", _
    Optional ByVal FileNome$ = "", Optional ByVal Titolo$ = "") As String
'
'   Imposta i valori di una finestra per la gestione dei Files
'   e ritorna il nome completo del File scelto.
'   La gestione degli errori (e.g. cdlCancel) va' fatta nella
'   routine chiamante.
'
'   Parametri:
'    CMDialog:  e' il controllo Common Dialog che si intende usare.
'    Oper$:     operazione da eseguire (solo "Save" o "Open").
'    Tipo$:     tipo dei files da proporre (e.g. "Filtri IIR").
'    Ext$:      estensioni dei files da proporre (e.g. "*.dat[;*.txt]").
'    DirNome$:  Folder di default.
'    FileNome$: nome del File di default.
'    Titolo$:   titolo della finestra.
'
    Dim Filter$
'
    If Oper$ <> "Open" And Oper$ <> "Save" Then Err.Raise 5
'
    ' Prepara ed imposta tipo ed estensioni dei
    ' files da proporre:
    Filter$ = Tipo$ & " (" & Ext$ & ")|" & Ext$ & "|"
    Filter$ = Filter$ & "Tutti i Files (*.*)|*.*"
    CMDialog.Filter = Filter$
    CMDialog.FilterIndex = 1
'
    ' Imposta il Folder di default:
    If DirNome$ <> "" Then
        CMDialog.InitDir = DirNome$
    Else
        CMDialog.InitDir = App.Path
    End If
'
    ' Imposta il File Name di default:
    If FileNome$ <> "" Then
        CMDialog.FileName = FileNome$
    Else
        If Oper$ = "Open" Then
            CMDialog.FileName = ""
        ElseIf Oper$ = "Save" Then
            CMDialog.FileName = Left$(Ext$, 5)
        End If
    End If
'
    ' Scrive il titolo della finestra:
    CMDialog.DialogTitle = " " & Titolo$
'
    ' Controlla l' esistenza del File, chiede conferma
    ' se File Already Exists, nasconde la casella Read Only:
    CMDialog.Flags = cdlOFNFileMustExist + cdlOFNOverwritePrompt _
                   + cdlOFNHideReadOnly
    ' e permette il Cancel:
    CMDialog.CancelError = True
'
    ' Apre la finestra con
    ' l' operazione richiesta:
    If Oper$ = "Open" Then
        CMDialog.ShowOpen
    ElseIf Oper$ = "Save" Then
        CMDialog.ShowSave
    End If
'
    CMDialog_Files = CMDialog.FileName
'
'
'
End Function
Public Function DMIN1(ParamArray Vd() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMin = Vd(J1)
    For J = J1 + 1 To J2
        If vDMin > Vd(J) Then vDMin = Vd(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function DMAX1(ParamArray Vd() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMax = Vd(J1)
    For J = J1 + 1 To J2
        If vDMax < Vd(J) Then vDMax = Vd(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function Quadro(ByVal Foglio As PictureBox, _
    ByRef X0#, ByRef Xn#, ByRef Y0#, ByRef Yn#, _
    Optional ByVal FormatVX$ = "#0.0##", _
    Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal Npx& = 1, Optional ByRef PxN_X!, Optional ByRef PxN_Y!, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", _
    Optional ByVal UnitaY$ = "", _
    Optional ByVal AutoRed As Boolean = False, _
    Optional ByVal RifCol& = vbGreen, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByRef tEsec!) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'    Parametri in ingresso:
'     Foglio:    PictureBox da scalare.
'     X0:        Valore minimo di ascissa da rappresentare.
'     Xn:        Valore massimo di ascissa da rappresentare.
'                Deve essere X0 <= Xn.
'     Y0:        Valore minimo di ordinata da rappresentare.
'     Yn:        Valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: Stringa di formato dei valori sull' asse X.
'     FormatVY$: Stringa di formato dei valori sull' asse Y.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   Titolo del grafico.
'     UnitaX$:   Unita' (o titolo) dell' asse X.
'     UnitaY$:   Unita' (o titolo) dell' asse Y.
'     AutoRed:   Stato di Foglio.AutoRedraw dopo il disegno del quadro.
'     RifCol:    Colore degli assi, dei valori e delle griglie di riferimento.
'     bGriglia:  Se True viene disegnata la griglia di riferimento:
'                se False viene fatta solo la scalatura di Foglio.
'    Parametri in uscita:
'     X0:        Valore minimo di ascissa rappresentata.
'     Xn:        Valore massimo di ascissa rappresentata.
'     Y0:        Valore minimo di ordinata rappresentata.
'     Yn:        Valore massimo di ordinata rappresentata.
'     PxN_X:     Larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx [Pixels].
'     tEsec:     tempo impiegato a disegnare il quadro [s].
'
'   Rev. 25/03/2003
'
    Dim I&, XI!, D_X!, rrx!, YI!, D_Y!, rry!, Txt$
    Dim QxMin!, QxMax!, QYMin!, QYMax!, TxW!
'
    tEsec = Timer
    On Error GoTo Quadro_ERR
'
    ' Verifico la correttezza delle scale:
    If X0 > Xn Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If Y0 > Yn Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
'-------------------------------------------------------------------------------------
'   Calcolo del passo di grigliatura degli assi.
'
    Dim DYMin!
    Const ScRis& = 3                ' La risoluzione delle scale e' 10 ^ -ScRis.
    Const ScMin! = 10 ^ (1 - ScRis) ' Ampiezza min. delle scale X e Y.
    Const Log10! = 2.30258509299405 ' Log(10#)
'
    ' Imposto una scala minima
    ' per l' asse X:
    If Xn - X0 < ScMin Then
        X0 = X0 - ScMin / 2!
        Xn = Xn + ScMin / 2!
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
    D_X = Xn - X0
    rrx = 10! ^ Ceil(Log(D_X / 20!) / Log10)
    Do While D_X / rrx < 5!
        rrx = rrx / 2!
    Loop
    If D_X / rrx > 10! Then rrx = rrx * 2!
    X0 = rrx * Int(Round(X0 / rrx, ScRis))
    Xn = rrx * Ceil(Round(Xn / rrx, ScRis))
    D_X = Xn - X0
'
    ' Imposto una scala minima
    ' per l' asse Y:
    If Format$(Y0, FormatVY$) = Format$(Yn, FormatVY$) Then
        DYMin = 0.0001
        Do While Format$(Y0 - DYMin, FormatVY$) = Format$(Yn + DYMin, FormatVY$)
            DYMin = 2! * DYMin
        Loop
'
        Y0 = Y0 - 10! * DYMin
        Yn = Yn + 10! * DYMin
    End If
'
    ' Calcolo la spaziatura dei valori scritti
    ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
    D_Y = Yn - Y0
    rry = 10! ^ Ceil(Log(D_Y / 20!) / Log10)
    Do While D_Y / rry < 5!
        rry = rry / 2!
    Loop
    If D_Y / rry > 10! Then rry = rry * 2!
    Y0 = rry * Int(Round(Y0 / rry, ScRis))
    Yn = rry * Ceil(Round(Yn / rry, ScRis))
    D_Y = Yn - Y0
'
'-------------------------------------------------------------------------------------
'   Calcola larghezza ed altezza dei bordi.
'
    Dim Bl!, Br!, Bb!, Bt!, BDen!
    Dim TxWs!, TxWd!, TxHt!, TxHb!
'
    ' Imposto i dati di Font dei valori
    ' degli assi:
    Foglio.FontName = "MS Sans Serif"
    Foglio.FontSize = 8
    Foglio.FontBold = False
'
    ' Annullo le scale precedenti:
    Foglio.ScaleMode = vbPixels
'
    ' Il bordo a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    TxWs = Foglio.TextWidth(Format$(Y0, FormatVY$) & "W")
    If TxWs < Foglio.TextWidth(Format$(Yn, FormatVY$) & "W") Then
        TxWs = Foglio.TextWidth(Format$(Yn, FormatVY$) & "W")
    End If
'
    ' Il bordo a destra deve essere sufficiente
    ' a contenere il valore Xn e l' etichetta UnitaX$:
    TxWd = (Foglio.TextWidth(Format$(Xn, FormatVX$)) / 2!) _
         + Foglio.TextWidth(UnitaX$ & "W")
'
    ' I bordi a sinistra ed a destra sono:
    BDen = D_X / (Foglio.ScaleWidth - TxWs - TxWd)
    Bl = TxWs * BDen
    Br = TxWd * BDen
'
    ' Il bordo sotto e' 2 volte l' altezza dei valori:
    TxHb = 2! * Abs(Foglio.TextHeight("H"))
'
    ' Il bordo sopra e' 2 volte l' altezza dei valori
    ' piu' l' altezza del titolo:
    Foglio.FontSize = 12
    TxHt = TxHb + Abs(Foglio.TextHeight(Titolo$))
'
    ' I bordi sopra e sotto sono:
    BDen = D_Y / (Abs(Foglio.ScaleHeight) + TxHb + TxHt)
    Bb = TxHb * BDen
    Bt = TxHt * BDen
'
'-------------------------------------------------------------------------------------
'   Imposta la scala e calcola i valori comuni.
'
    Dim Po4_X!, Po4_Y!, EstAx!, EstAy!
'
    ' Imposto i bordi orizzontali
    ' e verticali:
    QxMin = X0 - Bl
    QxMax = X0 + D_X + Br
    QYMin = Y0 - Bb
    QYMax = Y0 + D_Y + Bt
'
    ' La scalatura deve essere permanente:
    Foglio.AutoRedraw = True
'
    ' Imposto la scala e cancello il Foglio:
    Foglio.Scale (QxMin, QYMax)-(QxMax, QYMin)
    Foglio.Line (QxMin, QYMin)-(QxMax, QYMax), Foglio.BackColor, BF ' Questo e' piu' veloce
                                                                    ' di Foglio.Cls.
'
    ' Calcolo larghezza ed altezza di Npx pixels:
    PxN_X = Abs(Foglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(Foglio.ScaleY(Npx, vbPixels, vbUser))
    ' Calcolo larghezza ed altezza di 4 points:
    Po4_X = Foglio.ScaleX(4, vbPoints, vbUser)  ' Uso i [Points] perche' voglio dimensioni
    Po4_Y = Foglio.ScaleY(4, vbPoints, vbUser)  ' proporzionali a quelle dei caratteri.
'
    ' Estremita' degli assi X e Y:
    EstAx = (Xn + QxMax) / 2!
    EstAy = (Yn + QYMax) / 2!
'
    ' Verifico se e' richiesto il
    ' disegno della griglia:
    If Not bGriglia Then GoTo Fine
'
'-------------------------------------------------------------------------------------
'   Disegna assi, griglie e scrive i valori di scala.
'
    Foglio.FontSize = 8
    Foglio.DrawWidth = 1
    Foglio.DrawMode = vbCopyPen
    Foglio.ForeColor = RifCol
'
    ' Traccio la griglia verticale e scrivo
    ' i valori dell' asse X:
    Foglio.DrawStyle = vbDash
    For XI = X0 To Xn + 0.1 * rrx Step rrx
        Foglio.Line (XI, Y0)-(XI, Yn), RifCol
        Txt$ = Format$(XI, FormatVX$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        If Abs(XI - Val(Txt$)) < rrx / 10 Then
            Foglio.CurrentX = XI - Foglio.TextWidth(Txt$) / 2!
            Foglio.CurrentY = Y0 + Po4_Y / 2!
            Foglio.Print Txt$;
        End If
    Next XI
    ' Scrivo l' etichetta dell' asse X:
    If Len(UnitaX$) > 0 Then
        ' Etichetta tutta a destra:
        'Foglio.CurrentX = QxMax - Foglio.TextWidth(UnitaX$ & " ")
        ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
        Foglio.CurrentX = (Foglio.CurrentX + QxMax - Foglio.TextWidth(UnitaX$)) / 2!
        Foglio.CurrentY = Y0 + Po4_Y / 2!
        Foglio.Print UnitaX$;
    End If
    ' Traccio l' asse Y:
    If (X0 <= 0!) And (0! <= Xn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (0!, Y0)-(0!, EstAy), RifCol
        Foglio.Line (0!, EstAy)-(-Po4_X / 2!, Po4_Y + EstAy), RifCol
        Foglio.Line (0!, EstAy)-(Po4_X / 2!, Po4_Y + EstAy), RifCol
    End If
'
    ' Traccio la griglia orizzontale e scrivo
    ' i valori dell' asse Y:
    Foglio.DrawStyle = vbDash
    For YI = Y0 To Yn + 0.1 * rry Step rry
        Foglio.Line (X0, YI)-(Xn, YI), RifCol
        Txt$ = Format$(YI, FormatVY$)
        ' Verifico che il formato scelto non
        ' induca ad errori di rappresentazione:
        'If Abs(YI - Val(Txt$)) < rry / 10 Then
            Foglio.CurrentX = QxMin
            Foglio.CurrentY = YI - Foglio.TextHeight(Txt$) / 2!
            Foglio.Print Txt$;
        'End If
     Next YI
    ' Scrivo l' etichetta dell' asse Y:
    If Len(UnitaY$) > 0 Then
        Foglio.CurrentX = QxMin
        Foglio.CurrentY = QYMax
        Foglio.Print UnitaY$;
    End If
    ' Traccio l' asse X:
    If (Y0 <= 0!) And (0! <= Yn) Then
        Foglio.DrawStyle = vbSolid
        Foglio.Line (X0, 0!)-(EstAx, 0!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, -Po4_Y / 2!), RifCol
        Foglio.Line (EstAx, 0!)-(EstAx - Po4_X, Po4_Y / 2!), RifCol
    End If
'
'-------------------------------------------------------------------------------------
'   Scrive il titolo del grafico:
'
    Dim TitL!, TitT!, TitW!, TitH!
'
    If Len(Titolo$) > 0 Then
        Foglio.FontSize = 12
        Foglio.FontBold = True
        Foglio.ForeColor = vbRed
'
        TitW = Foglio.TextWidth(Titolo$)
        TitH = Foglio.TextHeight(Titolo$)
        ' Verifico che il titolo stia tutto nel Foglio:
        If TitW <= Foglio.ScaleWidth Then
            TitL = (QxMin + QxMax - TitW) / 2!
        ' e se no' lo taglio:
        Else
            TitL = Foglio.ScaleLeft
            Txt$ = " . . . ."
            Titolo$ = Left$(Titolo$, Int(Len(Titolo$) * _
            (Foglio.ScaleWidth - Foglio.TextWidth(Txt$)) / TitW)) & Txt$
        End If
        TitT = QYMax
        ' Cancello l' area su cui andra' scritto il titolo:
        'Foglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), Foglio.BackColor, BF
        Foglio.CurrentX = TitL
        Foglio.CurrentY = TitT
        Foglio.Print Titolo$
    End If
'
Fine:
    Foglio.DrawStyle = vbSolid
    Foglio.AutoRedraw = AutoRed
'
'
Quadro_ERR:
    Quadro = (Err = 0)
    If Err <> 0 Then
        MsgBox Err.Description, vbCritical, " Quadro/" & Err.Source
    End If
    tEsec = Timer - tEsec
'
'
'
End Function
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If X = Int(X) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Public Function MAX0(ParamArray Vd() As Variant) As Long
'
'   Implementa la funzione MAX0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMax = Vd(J1)
    For J = J1 + 1 To J2
        If vDMax < Vd(J) Then vDMax = Vd(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Function MIN0(ParamArray Vd() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(Vd)
    J2 = UBound(Vd)
    vDMin = Vd(J1)
    For J = J1 + 1 To J2
        If vDMin > Vd(J) Then vDMin = Vd(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef PName$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'    Full$  = Nome completo del File.
'    PName$ = Path del File (con \ finale).
'    FName$ = Nome del File con Estensione.
'    Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        PName$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            PName$ = PName$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        PName$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If Dot <> 0 Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Private Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim res&
'
    On Error Resume Next
'
    res = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Function Atan2(ByVal Y#, ByVal X#) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x su 4 Quadranti.
'   E':    0 <= Atan2 < 2 * PI.
'
    Select Case X
    Case Is > 0#
        If Y >= 0# Then
            Atan2 = Atn(Y / X)
        Else
            Atan2 = Atn(Y / X) + PI2
        End If
'
    Case Is < 0#
        Atan2 = Atn(Y / X) + PI
'
    Case Is = 0#
        Atan2 = Sgn(Y) * PI / 2#
    End Select
'
'
'
End Function
Public Function DMINVAL(dVet#()) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If dDMin > dVet(J) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
Public Function DMAXVAL(dVet#()) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If dDMax < dVet(J) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function

